# A guide to effective docker deployment for Open Cloud

We need a reliable process using the existing tools and the creation of new one to have a consistant deployment of Open Cloud when each service is running in a docker container.

This document aims at addressing :
- The existing tools used
- The functionning of said tools
- The needed improvement (bugs/new features)
- The required configuration for each service

## Steps

- Downloading the repos : `oc-deploy/download_oc.py` uses the interactivity offered by python's library to select and follow the cloning of the repos on the forge, `oc-deploy/clone_opencloud_microservices.sh` is more straifhtforward using bash.

- Selecting the services to launch : `build_containers.sh` asks the user for the services that need to be launched. The user can choose non essential services (in front, monitord and shared) to be added to tthe list of minimum service to run open cloud (auth, catalog, datacenter, peer, workspace, worflow, scheduler, schedulerd)

- Verify if the service really need a `docker build` : this operation is time and resource consumming, so we need to check :
    - is a container already runs
    - does an image already exist

    and prompt the user if he wants to proceed with the build, or just start a container with the existing image or let the the current container run.

- Fill the configuration file for each service selected to be built.

## Todo

- Implement a script that interacts with the user to fill the configuration json file

- Remove the filed json file from the forge to prevent that data from other dev are stored and used during build, which would lead the services to be missconfigured
    - We could let some generic value, like ports, container addresses...
